# API Host and URL
HOST = 'analytics2'
API_BASE_URL = f'https://{HOST}.smtresearch.ca/api/index.php?action='


# File Paths
CSV_DATA_PATH   = '/home/pi/csv-data/data.csv'
DATABASE_PATH   = '/home/pi/.database/BiG.sqlite'
DEV_INFO_PATH   = '/home/pi/device-info/dev_info.txt'
LOGGING_PATH    = '/home/pi/.log/BiG.log'
SCHEMA_PATH     = '/home/pi/schema/schema_local.xml'
TMATE_CONF_PATH = '/home/pi/.tmate.conf'


# Chunk Sizes
DATA_CHUNK_SIZE = 10_000
SYNC_CHUNK_SIZE = 10_000


# RPi Pins
STATUS_R_PIN = 8 
STATUS_G_PIN = 10 
SYNC_R_PIN   = 11 
SYNC_G_PIN   = 13
B_PIN        = 29
A_PIN        = 38
SYNC_BTN_PIN = 33
WIFI_BTN_PIN = 35
PWR_BTN_PIN  = 37
RELAY_PIN    = 15


# USB Commands
USB_GET_ID     = 0x01
USB_PING_SRC   = 0x39
USB_ACK_PING   = 0x40
USB_RETRANSMIT = 0x41
USB_ERASE      = 0x42
USB_SET_PAN    = 0x52
USB_GET_PAN    = 0x53
USB_START_LOG  = 0x92
USB_END_LOG    = 0x93
USB_DATA_SET   = 0xA0
USB_GET_RTC    = 0xA3
USB_SET_RTC    = 0xA4
USB_ENABLE_CH  = 0xF1
USB_DISABLE_CH = 0xF2


# ZMQ Commands (some are not used)
STATUS_LED_OFF         = 100
STATUS_LED_RED         = 101
STATUS_LED_GREEN       = 102
STATUS_LED_BLINK_RED   = 103
STATUS_LED_BLINK_GREEN = 104

SYNC_LED_OFF         = 200
SYNC_LED_RED         = 201
SYNC_LED_GREEN       = 202
SYNC_LED_BLINK_RED   = 203
SYNC_LED_BLINK_GREEN = 204

A_LED_ON    = 300
A_LED_OFF   = 301
A_LED_BLINK = 302

B_LED_ON    = 400
B_LED_OFF   = 401
B_LED_BLINK = 402


ZMQ_SOCKET = 'tcp://127.0.0.1:1980'