from constants import RELAY_PIN
from database import Database
import RPi.GPIO as GPIO


class Relay(Database):
    """
    A relay object is required anytime rows are being inserted
    into the data table of the local sqlite database

    An instance of this class is created in
    sync.py and usbhub.py
    """

    def __init__(self):
        self.connect()
        
        self.con.create_function("alarm_on",  3, self.alarm_on)
        self.con.create_function("alarm_off", 3, self.alarm_off)

        GPIO.setwarnings(False)
        GPIO.setmode(GPIO.BOARD)
        GPIO.setup(RELAY_PIN, GPIO.OUT)

    
    def alarm_on(self, phy_id:int, sensor_input:int, relay:int):
        if relay: GPIO.output(RELAY_PIN, 1)


    def alarm_off(self, phy_id:int, sensor_input:int, relay:int):
        if relay: GPIO.output(RELAY_PIN, 0)


    def check_alarms(self):
        query = 'SELECT phyID, input, relay FROM alarms WHERE onCount >= onReadings'
        for phy_id, sensor_input, relay in self.select(query, fetch_one=False):
            self.alarm_on(phy_id, sensor_input, relay)
