$.ajax({
    url: 'includes/nodelist.php',
    type: "POST",
    data: {sensorgraph: "graph"},
    success: function(result){
	getResponse(result.split('<')[0]); // remove all html from response.
    },
    fail: function( xhr, textStatus, errorThrown){
	console.log("failed");
    }
}).done(function(response){
    console.log("finished");
});

function getResponse(resultData){
	var parsedJSONData = JSON.parse(resultData);
	var graphData = [];
	
	for(let i = 0; i < parsedJSONData.length; i++){
		graphData.push({
			"x": new Date(parsedJSONData[i]['ts']*1000),
			"y": parsedJSONData[i]['value']
		});
	}

var chartConfigV2 = {
    type: 'line',
    data: {
	datasets: [{
	    data: graphData,
	    label: "Value",
	    borderColor: "#005bbf",
	    fill: false
	}]
    },
    options: {
	responsive: true,
	layout: {
	    padding: {
		left: 5,
		right: 5,
		top: 50,
		bottom: 5 
	    }
	},
	legend: {
	    display: false
	},
	clip: false,
	title: {
	    fontStyle: 'bold',
	    display: true,
	    text: "Sensor Data",
	    fontSize: 20,
	    padding: 10
	},
	scales: {
	    yAxes: [{
		beginAtZero: true
	    }],
	    xAxes: [{
		type: "time",
		time: {
		    unit: 'second',
		    distribution: 'linear',
		    displayFormats: {
			second: 'MMM DD YY hh:mm a'
		    },
		    tooltipFormat: 'hh:mm:ss a'
		},
		ticks: {
		    source: 'data',
		    autoSkip: true,
		    fontSize: 10,
		    maxTicksLimit: 20
		},
		title: {
		    display: true,
		    text: "date"
		}
	    }]
	}
    }
};

new Chart(document.getElementById("chart"), chartConfigV2);

}
