<?php

require_once 'includes/status_messages.php';

function DeleteAlarm($db, $alarmName, &$alarms)
{
	$db->query("DELETE FROM alarms WHERE name = '$alarmName'");
	$db->query('DROP TRIGGER '.$alarmName.'_onTrigger');
	$db->query('DROP TRIGGER '.$alarmName.'_offTrigger');

	# Remove alarm from alarms array
	$key = 'Edit alarm'.' '."'".$alarmName."'";
	unset($alarms[$key]);
}

function ValidInput($onInequality, $offInequality, $onValue, $offValue)
{
	if (
		($onInequality == '='  && $offInequality == '='  && $onValue == $offValue) ||
		($onInequality == '='  && $offInequality == '>'  && $onValue >  $offValue) ||
		($onInequality == '='  && $offInequality == '<'  && $onValue <  $offValue) ||
		($onInequality == '='  && $offInequality == '>=' && $onValue >= $offValue) ||
		($onInequality == '='  && $offInequality == '<=' && $onValue <= $offValue) ||

		($onInequality == '>'  && $offInequality == '='  && $onValue <  $offValue) ||
		($onInequality == '>'  && $offInequality == '>'						     ) ||
		($onInequality == '>'  && $offInequality == '<'  && $onValue <  $offValue) ||
		($onInequality == '>'  && $offInequality == '>=' 						 ) ||
		($onInequality == '>'  && $offInequality == '<=' && $onValue <  $offValue) ||

		($onInequality == '<'  && $offInequality == '='  && $onValue >  $offValue) ||
		($onInequality == '<'  && $offInequality == '>'  && $onValue >  $offValue) ||
		($onInequality == '<'  && $offInequality == '<'  						 ) ||
		($onInequality == '<'  && $offInequality == '>=' && $onValue >  $offValue) ||
		($onInequality == '<'  && $offInequality == '<=' 						 ) ||

		($onInequality == '>=' && $offInequality == '='  && $onValue <= $offValue) ||
		($onInequality == '>=' && $offInequality == '>'  					     ) ||
		($onInequality == '>=' && $offInequality == '<'  && $onValue <  $offValue) ||
		($onInequality == '>=' && $offInequality == '>=' 						 ) ||
		($onInequality == '>=' && $offInequality == '<=' && $onValue <= $offValue) ||

		($onInequality == '<=' && $offInequality == '='  && $onValue >= $offValue) ||
		($onInequality == '<=' && $offInequality == '>'  && $onValue >  $offValue) ||
		($onInequality == '<=' && $offInequality == '<'  						 ) ||
		($onInequality == '<=' && $offInequality == '>=' && $onValue >= $offValue) ||
		($onInequality == '<=' && $offInequality == '<=' 						 )
	){ return false; }

	return true;
}

function DisplayAlarms($db)
{
	# Variables
    $status = new StatusMessages();
	$createAlarmActive = true;
	$listAlarmsActive = false;
	$alarmsLogsActive = false;

	# Create array of alarms
	$dbRows = $db->query('SELECT * FROM alarms');
	$alarms = array('Create new alarm'=>'Create new alarm');
	while ($res = $dbRows->fetchArray()){
		$key = 'Edit alarm'.' '."'".$res['name']."'";
		$alarms[$key] = $res;
	}

	# Determine selected alarm
	$selectedAlarm = array_key_first($alarms);
	if (trim($_POST['alarms']) != "") $selectedAlarm = $_POST['alarms'];
	$createAlarm = ($selectedAlarm == 'Create new alarm') ? true : false;

	# Create array of nodes
	$dbRows = $db->query('SELECT nodeID, phyID, name FROM node');
	$nodes = array();
	while ($res = $dbRows->fetchArray()){
		if (trim($res['nodeID']) == "") $res['nodeID'] = '<no_nodeID>';
		$key = $res['nodeID'].' '.$res['phyID'].' '.$res['name'];
		$nodes[$key] = $res;
	}

	########################### Creating a new alarm ###########################
	if ($createAlarm){
		# Determine selected node
		$selectedNode = array_key_first($nodes);
		if (trim($_POST['nodes']) != "") $selectedNode = $_POST['nodes'];

		# Create array of sensors
		$phyID = $nodes[$selectedNode][1];
		$dbRows = $db->query("SELECT input, name FROM sensor WHERE phyID = $phyID");
		$sensors = array();
		while ($res = $dbRows->fetchArray()){
			$key = $res['input'].' '.$res['name'];
			$sensors[$key] = $res;
		}
	}
	######################## Editing an existing alarm #########################
	else {
		$alarmInfo = $alarms[$selectedAlarm];
		
		# Determine selected node
		foreach (array_keys($nodes) as $key){
			if ($nodes[$key][1] == $alarmInfo[0]){ # compare phyID's
				$selectedNode = $key; break;
			}
		}
		if (trim($_POST['nodes2']) != "") $selectedNode = $_POST['nodes2'];

		# Create array of sensors
		$phyID = $nodes[$selectedNode][1];
		$dbRows = $db->query("SELECT input, name FROM sensor WHERE phyID = $phyID");
		$sensors = array();
		while ($res = $dbRows->fetchArray()){
			$key = $res['input'].' '.$res['name'];
			$sensors[$key] = $res;
			# Determine selected sensor
			if ($res['input'] == $alarmInfo[1] && $phyID == $alarmInfo[0]){
				$selectedSensor = $key;
			}
		}
	}
	############################################################################

	if (isset($_POST['createAlarm']) || isset($_POST['updateAlarm'])){

		if ($createAlarm){
			$phyID = $nodes[$_POST['nodes']][1];
		}else{
			$phyID = $nodes[$_POST['nodes2']][1];
			$currentName = $alarmInfo[2];
		}
		$input = $sensors[$_POST['sensors']][0];
		$alarmName     = $_POST['alarmName'];
		$onInequality  = $_POST['onInequality'];
		$onValue       = $_POST['onValue'];
		$onReadings    = $_POST['onReadings'];
		$offInequality = $_POST['offInequality'];
		$offValue 	   = $_POST['offValue'];
		$offReadings   = $_POST['offReadings'];
		$relay 		   = isset($_POST['assignRelay']) ? 1 : 0;
		$created 	   = gmdate('Y-m-d H:i:s');

		if (trim($alarmName)=="" || trim($onValue)=="" || trim($onReadings)=="" || trim($offValue)=="" || trim($offReadings)==""){
			$status->addMessage('Must fill in all fields', 'danger');
		}
		else if (preg_match("/^[\w\s\-]*$/", $alarmName) != 1){
			$status->addMessage('Name contains illegal characters. Allowed characters: a-z, A-Z, 0-9, -, _, and spaces', 'danger');
		}
		else{
			$alarmName = str_replace(' ', '_', $alarmName); # Replace spaces with underscores
			$query = "SELECT 1 FROM alarms WHERE name = '$alarmName'";
			$res1 = $db->query($query)->fetchArray()[0];

			$query  = "SELECT name FROM alarms WHERE phyID=$phyID AND input=$input ";
			$query .= "AND onInequality='$onInequality' AND onValue=$onValue AND onReadings=$onReadings ";
			$query .= "AND offInequality='$offInequality' AND offValue=$offValue AND offReadings=$offReadings";
			$res2 = $db->query($query)->fetchArray()[0];

			# Creating new alarm but name is taken
			if ($createAlarm && $res1 == 1){
				$status->addMessage("An alarm already exists with the name '$alarmName'", 'danger');	
			}
			# Editing alarm and changed name to a name that is taken
			else if (!$createAlarm && $currentName != $alarmName && $res1 == 1){
				$status->addMessage("An alarm already exists with the name '$alarmName'", 'danger');	
			}
			# Creating new alarm but alarm with same criteria already exists
			else if ($createAlarm && trim($res2) != ""){
				$status->addMessage("An alarm already exists with this criteria. Name of alarm: '$res2'", 'danger');
			}
			# Editing alarm, not changing name or anything to do with the relay
			# but an alarm with the same criteria already exists
			else if (!$createAlarm && $currentName == $alarmName && $alarmInfo[11] == $relay && trim($res2) != ""){
				$status->addMessage("An alarm already exists with this criteria. Name of alarm: '$res2'", 'danger');
			}
			# Combination of onInequality, offInequality, onValue, offValue doesn't make sense
			else if (!ValidInput($onInequality, $offInequality, $onValue, $offValue)){
				$status->addMessage('Create Alarm - Input is invalid', 'warning');
			}
			# All good
			else{
				# If editing this alarm, delete it first
				if (!$createAlarm) DeleteAlarm($db, $currentName, $alarms);

				# Add row to alarms table
				$query  = "INSERT INTO alarms VALUES ($phyID, $input, '$alarmName', '$onInequality', $onValue, ";
				$query .= "$onReadings, 0, '$offInequality', $offValue, $offReadings, 0, $relay, '$created')";
				$db->query($query);

				# Create "on" trigger
				$query  = 'CREATE TRIGGER '.$alarmName.'_onTrigger AFTER INSERT ON data ';
				$query .= "WHEN NEW.value $onInequality $onValue AND NEW.node = $phyID AND NEW.input = $input BEGIN ";
				$query .= "UPDATE alarms SET offCount = 0 WHERE name = '$alarmName'; ";
				$query .= "UPDATE alarms SET onCount = onCount+1 WHERE name = '$alarmName'; ";
				$query .= "END;";
				$db->query($query);

				# Create "off" trigger
				$query  = 'CREATE TRIGGER '.$alarmName.'_offTrigger AFTER INSERT ON data ';
				$query .= "WHEN NEW.value $offInequality $offValue AND NEW.node = $phyID AND NEW.input = $input BEGIN ";
				$query .= "UPDATE alarms SET offCount = offCount+1 WHERE name = '$alarmName'; ";
				$query .= "END;";
				$db->query($query);
				
				# Add alarm to alarms array
				$key = 'Edit alarm'.' '."'".$alarmName."'";
				$alarms[$key] = $db->query("SELECT * FROM alarms WHERE name = '$alarmName'")->fetchArray();

				if ($createAlarm){
					$status->addMessage("Alarm '$alarmName' created");
				}else{
					$status->addMessage("Alarm '$currentName' updated");

					if ($alarmName != $currentName){ # If name changed
						$db->query("UPDATE alarmLogs SET name = '$alarmName' WHERE name = '$currentName'");
					}

					$selectedAlarm = array_key_first($alarms);
					$currentName = $alarmName;
					$createAlarm = true;
				}
			} # else
		} # else

		$status->showMessages();
    }
	else if (isset($_POST['deleteAlarm'])){
		$alarmName = $alarmInfo[2];
		DeleteAlarm($db, $alarmName, $alarms);

		$status->addMessage("Alarm '$alarmName' deleted");
		$status->showMessages();

		$selectedAlarm = array_key_first($alarms);
		$createAlarm = true;
	}
	else{
		foreach (array_keys($alarms) as $alarmKey){
			$alarmName = $alarms[$alarmKey][2];
			if (isset($_POST["editAlarm_$alarmName"])){
				$createAlarm = false;
				$selectedAlarm = $alarmKey;
				$alarmInfo = $alarms[$selectedAlarm];
		
				# Determine selected node
				foreach (array_keys($nodes) as $key){
					if ($nodes[$key][1] == $alarmInfo[0]){ # compare phyID's
						$selectedNode = $key; break;
					}
				}
				if (trim($_POST['nodes2']) != "") $selectedNode = $_POST['nodes2'];

				# Create array of sensors
				$phyID = $nodes[$selectedNode][1];
				$dbRows = $db->query("SELECT input, name FROM sensor WHERE phyID = $phyID");
				$sensors = array();
				while ($res = $dbRows->fetchArray()){
					$key = $res['input'].' '.$res['name'];
					$sensors[$key] = $res;
					# Determine selected sensor
					if ($res['input'] == $alarmInfo[1] && $phyID == $alarmInfo[0]){
						$selectedSensor = $key;
					}
				}
				break;
			}
			else if (isset($_POST["deleteAlarm_$alarmName"])){
				DeleteAlarm($db, $alarmName, $alarms);

				$status->addMessage("Alarm '$alarmName' deleted");
				$status->showMessages();

				$selectedAlarm = array_key_first($alarms);
				$createAlarm = true;

				break;
			}
			else if (isset($_POST["resetAlarm_$alarmName"])){
				$relay = $alarms[$alarmKey][11];
				$cmd = "python3 /home/pi/python-scripts/functions.py --alarmName=$alarmName --relay=$relay";
				shell_exec($cmd);

				$status->addMessage("Alarm '$alarmName' reset");
				$status->showMessages();
				break;
			}
		}
	}

	# Arrays for drop-down selectors
	$alarmSelector   = array_keys($alarms);
	$nodeSelector    = array_keys($nodes);
	$sensorSelector  = array_keys($sensors);
	$inequalityArray = array('=', '>', '<', '>=', '<=');

	# Number of relays currently assigned to alarms
	$relaysUsed = $db->query("SELECT count(name) FROM alarms WHERE relay != 0")->fetchArray()[0];

	# For logs tab -> make array of alarm names
	$alarmNames = array('All');
	foreach ($alarms as $alarm){ 
		if ($alarm != array_key_first($alarms)){
			array_push($alarmNames, $alarm[2]);
		}
	}

	$selectedName = $alarmNames[0];
	if (trim($_POST['alarmNames']) != "") $selectedName = $_POST['alarmNames'];

	if ($selectedName == $alarmNames[0]){
		$dbRows = $db->query("SELECT * FROM alarmLogs");
	}else{
		$dbRows = $db->query("SELECT * FROM alarmLogs WHERE name = '$selectedName'");
	}

	$logTableRows = array();
	while ($res = $dbRows->fetchArray()){
		array_push($logTableRows, $res);
	}
    
    echo renderTemplate(
		"alarms", compact(
		"createAlarmActive",
		"listAlarmsActive",
		"alarmsLogsActive",
		"createAlarm",
		"alarms",
		"alarmSelector",
		"selectedAlarm",
		"alarmInfo",
		"nodes",
		"nodeSelector",
		"selectedNode",
		"sensors",
		"sensorSelector",
		"selectedSensor",
		"inequalityArray",
		"relaysUsed",
		"alarmNames",
		"selectedName",
		"logTableRows"
		)
    );
}

?>
