<?php

require_once 'includes/status_messages.php';

function updateConfig($db, $I3, $key, $value)
{
    $db->query("UPDATE config SET value = $I3 WHERE key = 'I3node'");
    $db->query("UPDATE config SET value = $value WHERE key = '$key'");
}

function DisplayDevsConfig($db, $bbPID)
{
    $statusMessages   = new StatusMessages();
    $noI3NodeMessage  = new StatusMessages();
    $settingsMessages = new StatusMessages();
    $logsMessages     = new StatusMessages();
    
    exec('sudo bigberry writeUSBinfo');
    $devInfoStr = shell_exec('cat /home/pi/device-info/dev_info.txt');
    $devInfoArray = explode("\n", $devInfoStr);
    $numDevices = sizeof($devInfoArray)-1; # File has extra '\n'

    $devices = array();
    $nodesDropDown = array(); # Wimotes node IDs

    foreach ($devInfoArray as $dev){
        $info = explode("|", $dev);    
        array_push($devices, $info);
        if($info[0] == 'Wimote'){ array_push($nodesDropDown, $info[1]); }
    }

    $timerArray = array(
        'hour(s)'  =>'Hour(s)',
        'minute(s)'=>'Minute(s)',
        'second(s)'=>'Second(s)'
    );
    
    $confirmReTX  = false;
    $confirmErase = false;

    $I3 = $_POST['I3node'];

    if ($bbPID == 0){} # Can't do anything if BiGBerry is not running

    ############################################# PAN #############################################
    elseif (isset($_POST['setPAN'])){
        if (trim($I3) != ""){
            $pan = $_POST['pan'];
            if (trim($pan) != ""){
                updateConfig($db, $I3, 'pan', $pan);
                exec('sudo bigberry setPAN');
                $statusMessages->addMessage("Node: $I3 | New PAN: $pan");
            }else{$settingsMessages->addMessage('Set PAN - Must enter value', 'warning');}
        }else{$noI3NodeMessage->addMessage('Set PAN - No wimote selected', 'warning');}
    }
    ###############################################################################################

    ######################################## SAMPLING TIMER #######################################
    elseif (isset($_POST['setTimer'])){
        if (trim($I3) != ""){
            $timer = $_POST['timerValue'];
            if (trim($timer) != ""){
                $units = $_POST['timerUnits'];
                $errMsg = "";

                if ($units == 'hour(s)'){
                    if ($timer > 23 || $timer < 1){$errMsg = "Hours max value = 23, min value = 1";}
                    else{$value = $timer+192;}
                }
                elseif ($units == 'minute(s)'){
                    if ($timer > 59 || $timer < 1){$errMsg = "Minutes max value = 59, min value = 1";}
                    else{$value = $timer+128;}
                }
                elseif ($units == 'second(s)'){
                    if ($timer > 50 || $timer < 10 || $timer % 10 != 0){
                        $errMsg = "Seconds must be a multiple of 10 | max = 50, min = 10";
                    }else{$value = ($timer/10)+64;}
                }

                if ($errMsg == ""){ # Valid timer value entered
                    updateConfig($db, $I3, 'samplingTimer', $value);
                    exec('sudo bigberry setST');
                    $statusMessages->addMessage("Node: $I3 | New Sampling Timer: $timer $units");
                }else{$settingsMessages->addMessage("Set Timer - $errMsg", 'warning');}
            }else{$settingsMessages->addMessage('Set Timer - Must enter value', 'warning');}
        }else{$noI3NodeMessage->addMessage('Set Timer - No wimote selected', 'warning');}
    }
    ###############################################################################################

    ########################################## RETRANSMIT #########################################
    elseif (isset($_POST['reTX'])){
        if (trim($I3) != ""){
            $A3 = $_POST['A3node'];
            if (trim($A3) != ""){
                updateConfig($db, $I3, 'A3node', $A3);
                $logsMessages->addMessage("Node: $A3 | Confirm retransmit logs", 'danger');
                $confirmReTX = true;
            }else{ $logsMessages->addMessage('Retransmit - Must enter node', 'warning');}
        }else{$noI3NodeMessage->addMessage('Retransmit - No wimote selected', 'warning');}
    }

    elseif (isset($_POST['confirmReTX'])){
        exec('sudo bigberry reTX');
        $A3 = $db->query("SELECT value FROM config WHERE key = 'A3node'")->fetchArray()[0];
        $statusMessages->addMessage("Node: $A3 | Retransmitting logs");
    }
    ###############################################################################################

    ############################################ ERASE ############################################
    elseif (isset($_POST['erase'])){
        if (trim($I3) != ""){
            $A3 = $_POST['A3node'];
            if (trim($_POST['A3node']) != ""){
                updateConfig($db, $I3, 'A3node', $A3);
                $logsMessages->addMessage("Node: $A3 | Confirm erase logs", 'danger');
                $confirmErase = true;
            }else{$logsMessages->addMessage('Erase - Must enter node', 'warning');}
        }else{$noI3NodeMessage->addMessage('Erase - No wimote selected', 'warning');}
    }

    elseif (isset($_POST['confirmErase'])){
        exec('sudo bigberry erase');
        $A3 = $db->query("SELECT value FROM config WHERE key = 'A3node'")->fetchArray()[0];
        $statusMessages->addMessage("Node: $A3 | Erasing logs");
    }
    ###############################################################################################

    $statusMessages->showMessages();

    echo renderTemplate(
        "configure_devices", compact(
        "numDevices",
        "devInfoArray",
	    "devices",
	    "numDevices",
	    "nodesDropDown",
        "timerArray",
        "noI3NodeMessage",
        "settingsMessages",
        "logsMessages",
        "confirmReTX",
        "confirmErase"
        )
    );
}

?>
