<?php

if(isset($_POST['sensorgraph'])){
    session_start();

    $input = $_SESSION['selectedInput'];
    $phyID = $_SESSION['selectedPhyID'];

    $db = new SQLite3('/home/pi/.database/BiG.sqlite');
    $graphData = array();
    $result_size = 0;

    $query = "SELECT ts, value FROM data WHERE input=$input AND node=$phyID ORDER BY id DESC LIMIT 50";
    $res = $db->query($query);

    while($rowres = $res->fetchArray()){
        $graphData[$result_size] = $rowres;
        $result_size++;
    }

    echo json_encode($graphData);
}

function saveSensorEdit($db)
{
    $phyID = $_POST['hiddenPhyID2'];
    $inputNumber = Array();

    if (isset($_POST['hiddenSensorList'])){
	    $inputNumber = unserialize(base64_decode($_POST['hiddenSensorList']));
    }

    if (isset($_POST['hiddenNumOfInputs'])){
        $date = exec('date -u +"%Y-%m-%d %H:%M:%S"');

        $numOfInputs = $_POST['hiddenNumOfInputs'];
        for ($check = 0; $check < $numOfInputs; $check++){
            $string = "Input_$check";
            $newName = $_POST["$string"];
            $input = $inputNumber[$check]['input'];
            $query = "UPDATE sensor SET name='$newName', modified='$date' WHERE phyID=$phyID and input=$input";
            $db->query($query);
        }
    }
}

function saveNodeEdit($db)
{
    if (isset($_POST['nodeName'])){
        $phyID = $_POST['hiddenPhyID'];
        $nodeName = $_POST['nodeName'];
        $date = exec('date -u +"%Y-%m-%d %H:%M:%S"');

        $query = "UPDATE node SET name='$nodeName', modified='$date' WHERE phyID=$phyID";
        $db->query($query);
    } 
}

function DisplayNodeList($db, &$extraFooterScripts)
{
    $status = new StatusMessages();

    $getSensors = false;
    $getSensorGraph = false;
    $confirmDataDeletion = false;
    $confirmNodeDeletion = false;

    $nodeRows = $db->query('SELECT nodeID, phyID, name FROM node');
    $nodeList = array();
    $totalNodes = 0;

	$csvFileString = '';
    $csvFileReady = false;

    while ($res = $nodeRows->fetchArray()){
        if (isset($res['phyID'])){
			$nodeList[$totalNodes]['nodeID'] = $res['nodeID'];
			$nodeList[$totalNodes]['phyID'] = $res['phyID'];
			$nodeList[$totalNodes]['name'] = $res['name'];
			$totalNodes++;
		}
    }

    if (isset($_POST['getSensors'])){
	
		if (isset($_POST['nodes'])){
			$getSensors = true;
			
			$selectedNode  = $_POST['nodes'];
            $selectedName  = $nodeList[$selectedNode]['name'];
			$selectedPhyID = $nodeList[$selectedNode]['phyID'];

            $sensorRows = $db->query("SELECT *, max(ts) FROM data WHERE node=$selectedPhyID GROUP BY input");
            $sensorData = Array();
            $totalSensors = 0;

            while ($res = $sensorRows->fetchArray(SQLITE3_ASSOC)){
				$sensorData[$totalSensors]['node']  = $res['node'];
				$sensorData[$totalSensors]['input'] = $res['input'];
				$sensorData[$totalSensors]['value'] = $res['value'];
				$sensorData[$totalSensors]['ts'] = date('Y M j H:m:s O', $res['ts']);
				$totalSensors++;
            }
			
			$sensorRows = $db->query("SELECT input, name, phyID FROM sensor WHERE phyID=$selectedPhyID");
			$sensorNames = Array();
			$totalSensors = 0;

			while ($res = $sensorRows->fetchArray(SQLITE3_ASSOC)){
				$sensorNames[$totalSensors]['input'] = $res['input'];
				$sensorNames[$totalSensors]['name']  = $res['name'];
				$totalSensors++;
			}
		}
		else{
			$status->addMessage('Get Sensors - No node selected', "warning");
			$status->showMessages();
		}
    }
    elseif (isset($_POST['deleteData'])){
        if (isset($_POST['nodes'])){
			$selectedNode = $_POST['nodes'];
			$selectedPhyID = $nodeList[$selectedNode]['phyID'];
			$selectedName = $nodeList[$selectedNode]['name'];

			$confirmDataDeletion = true;
 		}
		else{
            $status->addMessage('Delete Synced Data - No node selected', "warning");
            $status->showMessages();	
		}
    }
    elseif (isset($_POST['confirmDeleteData'])){
        if (isset($_POST['hiddenPhyID'])){
			$selectedPhyID = $_POST['hiddenPhyID'];
			$selectedName = $_POST['hiddenName'];

            $db->query("DELETE FROM data WHERE node=$selectedPhyID");

			$status->addMessage("Synced Data Deleted | $selectedPhyID - $selectedName");
			$status->showMessages();
		}
    }
    elseif (isset($_POST['deleteNode'])){
        if (isset($_POST['nodes'])){
			$selectedNode = $_POST['nodes'];
			$selectedPhyID = $nodeList[$selectedNode]['phyID'];
			$selectedName = $nodeList[$selectedNode]['name'];

			$confirmNodeDeletion = true;
		}
		else{
			$status->addMessage('Delete Node - No node selected', "warning");
			$status->showMessages();
		}
    }
    elseif (isset($_POST['confirmDeleteNode'])){
        if (isset($_POST['hiddenPhyID'])){
			$selectedPhyID = $_POST['hiddenPhyID'];
			$selectedName = $_POST['hiddenName'];

            $db->query("DELETE FROM node WHERE phyID=$selectedPhyID");
            $db->query("DELETE FROM sensor WHERE phyID=$selectedPhyID");

			$status->addMessage("Node Deleted | $selectedPhyID - $selectedName");
			$status->showMessages();
		}
    }
    elseif (isset($_POST['updateSensorNames'])){
        saveSensorEdit($db);

		$status->addMessage("Sensor Names Updated");
		$status->showMessages();
    }
    elseif (isset($_POST['updateNodeName'])){
        saveNodeEdit($db);

		$status->addMessage("Node Name Updated");
		$status->showMessages();
    }
    elseif (isset($_POST['exportButton'])){

        $startDate = date('U', strtotime($_POST['startDate']));
        $endDate = date('U', strtotime($_POST['endDate']));

        if ($endDate > $startDate){

            $query = "SELECT node,input,STRFTIME('%Y-%m-%d %H:%M:%S',DATETIME(ts,'unixepoch')),STRFTIME('%Y-%m-%d %H:%M:%S',DATETIME(ts,'unixepoch','localtime')),value,value FROM data WHERE ts>'$startDate' AND ts<'$endDate'";
            $result = $db->query($query);

            $filePath = '/var/www/html/data.csv';
            $fp = fopen($filePath, 'w');

            if ($fp == true){
                while ($row = $result->fetchArray(SQLITE3_ASSOC)){ fputcsv($fp, $row); }
                fclose($fp);

                $csvFileString = file_get_contents($filePath);
                $csvFileString = str_replace('"', '', $csvFileString);
                file_put_contents($filePath, $csvFileString);

                $csvFileReady = true;
            }
            else{
                $status->addMessage('Export Database - Unable to open file', 'danger');
                $status->showMessages();
            }
        }
        else{
            $status->addMessage("Export Database - Dates not properly set", "warning");
            $status->showMessages();
        }
    }
    else{
        $numOfInputs = $_POST['hiddenNumOfInputs'];

        for ($i = 0; $i < $numOfInputs; $i++){
            if (isset($_POST["getGraph_$i"])){

                $hiddenSensorList = unserialize(base64_decode($_POST['hiddenSensorList']));
                $selectedInput = $hiddenSensorList[$i]['input'];
                $selectedSensorName = $hiddenSensorList[$i]['name'];
                $selectedPhyID = $_POST['hiddenPhyID2'];
        
                $status->addMessage("Graphing sensor data for: $selectedSensorName");
                $status->showMessages();
        
                session_start();

                $_SESSION['selectedInput'] = $selectedInput;
                $_SESSION['selectedPhyID'] = $selectedPhyID;

                $getSensorGraph = true;
                $extraFooterScripts[] = array('src'=>'app/js/sensorchart.js', 'defer'=>false);
                $extraFooterScripts[] = array('src'=>'app/js/Chart.bundle.min.js', 'defer'=>false);
        
                break;
            }
        }
    }

    echo renderTemplate(
        "nodelist", compact(
            "totalNodes",
            "totalSensors",
            "nodeList",
            "sensorData",
            "sensorNames",
            "selectedNode",
            "selectedName",
            "selectedPhyID",
            "getSensors",
            "getSensorGraph",
            "confirmDataDeletion",
            "confirmNodeDeletion",
            "csvFileString",
            "csvFileReady"
        )
    );
}

?>