<div class="row">
  <div class="col-lg-12">
    <div class="card">
      <div class="card-header">
        <div class="row">
          <div class="col">
            <i class="fas fa-laptop-code fa-fw mr-2"></i><?php echo _("Configure Deivces"); ?>
          </div><!--col-->
        </div><!--row-->
      </div><!--card-header--> 

			<div class="card-body">
				<form name="configure" method="POST">
					<?php echo CSRFTokenFieldTag() ?>
					<div class="card h-100">
						<div class="card-body">
							
							<!--Connected Devices / Node selection-->
							<h4 class="mt-3" style="position:relative; bottom:15px;"><?php echo _("Connected Devices: ".$numDevices); ?></h4>
							<?php $noI3NodeMessage->showMessages(); ?>
							<div class="col-sm">

								<?php 
								foreach ($devices as $dev){
									if ($dev[0] == 'Wimote'){
										$nodeID  = $dev[1];
										$pan     = $dev[2];
										$timer   = $dev[3];
										$running = $dev[4];
										?>
										<div class="row mb-1">
											<div class="info-value col-xs-3"><?php echo _('WIMOTE')?></div>
											<div class="info-item col-xs-3">&nbsp;&nbsp;&nbsp;&nbsp;Node ID:</div>
											<div class="info-value col-xs-3"><?php echo _($nodeID); ?></div>
											<div class="info-item col-xs-3">&nbsp;&nbsp;&nbsp;&nbsp;PAN:</div>
											<div class="info-value col-xs-3"><?php echo _($pan); ?></div>
											<div class="info-item col-xs-3">&nbsp;&nbsp;&nbsp;&nbsp;Sampling Timer:</div>
											<div class="info-value col-xs-3"><?php echo _($timer); ?></div>
											<div class="info-item col-xs-3">&nbsp;&nbsp;&nbsp;&nbsp;Running:</div>
											<div class="info-value col-xs-3"><?php echo _($running); ?></div>
										</div><!--row-->
									<?php }elseif ($dev[0] == 'CANKey'){
										$address = $dev[1];
										$running = $dev[2];
										?>
										<div class="row mb-1">
											<div class="info-value col-xs-3"><?php echo _('CANKEY')?></div>
											<div class="info-item col-xs-3">&nbsp;&nbsp;&nbsp;&nbsp;Address:</div>
											<div class="info-value col-xs-3"><?php echo _($address)?></div>
											<div class="info-item col-xs-3">&nbsp;&nbsp;&nbsp;&nbsp;Running:</div>
											<div class="info-value col-xs-3"><?php echo _($running)?></div>
										</div><!--row-->
									<?php } ?>
								<?php } ?>
	
								<!--I3 Node Drop-down-->
								<div class="row" style="position:relative; top:5px;">
									<h4 class="mt-3" style="font-size:20px;"><?php echo _("Wimote"); ?></h4>
									<div class="row" style="position:relative; left:24px; top:10px;">
										<?php SelectorOptions('I3node', $nodesDropDown) ?>
									</div>
								</div><!--row-->
							</div><!--col-sm-->
							<br>
							<hr class="sidebar-divider my-0">
							<br>
							
							<!--Settings-->
							<h4 class="mt-3" style="position:relative; bottom:15px;"><?php echo _("Settings"); ?></h4>
							<?php $settingsMessages->showMessages(); ?>
							<div class="col-sm">
								
								<!--PAN-->
								<div class="row" style="position:relative; bottom:4px;">
									<h4 class="mt-3" style="font-size:20px;"><?php echo _("PAN"); ?></h4>
									<input type="number" min="1" name="pan" id="pan" style="width:83px; height:30px; position:relative; left:23px; top:13px;">
								</div><!--row-->
								
								<!--Timer-->
								<div class="row" style="position:relative;  bottom:5px;">
									<h4 class="mt-3" style="font-size:20px;"><?php echo _("Timer"); ?></h4>
									<div class="row">
										<input type="number" min="1" name="timerValue" style="width:83px; height:30px; position:relative; left:23px; top:15px;">
										<div class="row" style="position:relative; left:50px; top:11px;">
											<?php SelectorOptions('timerUnits', $timerArray) ?>
										</div>
									</div><!--row-->
								</div><!--row-->
					
								<br>
								<input type="submit" class="btn btn-primary" value="<?php echo _("Set PAN"); ?>" name="setPAN" style="position:relative; right:10px;">
								<input type="submit" class="btn btn-primary" value="<?php echo _("Set Timer"); ?>" name="setTimer" style="position:relative; right:5px;">
							</div><!--col-sm-->
							
							<br>
              <hr class="sidebar-divider my-0">
              <br>
							
							<!--Logs-->
							<h4 class="mt-3" style="position:relative; bottom:15px;"><?php echo _("Logs"); ?></h4>
							<?php $logsMessages->showMessages(); ?>
							<div class=col-sm>
								<div class="row" style="position:relative; bottom:5px;">
									<h4 class="mt-3" style="font-size:20px;"><?php echo _("Node"); ?></h4> 
									<div class="row" style="position:relative; left:24px; top:5px;">
										<?php echo CSRFTokenFieldTag() ?>
										<input type="number" min="1" name="A3node" id="A3node" style="width:83px; height:30px; position:relative; top:8px;">
										<input type="submit" class="btn btn-warning" value="<?php echo _("ReTX"); ?>"  name="reTX"  style="position:relative; left:10px; top:3px; height:40px">
										<input type="submit" class="btn btn-danger"  value="<?php echo _("Erase"); ?>" name="erase" style="position:relative; left:20px; top:3px; height:40px">
									</div><!--row-->
								</div><!--row-->
							</div><!--col-sm-->
							<br>
							<?php if ($confirmReTX): ?>
								<input type="submit" class="btn btn-danger" value="<?php echo _("Confirm ReTX"); ?>" name="confirmReTX" style="position:relative; bottom:10px;">
							<?php endif ?>
							<?php if ($confirmErase): ?>
								<input type="submit" class="btn btn-danger" value="<?php echo _("Confirm Erase"); ?>" name="confirmErase" style="position:relative; bottom:10px;">
							<?php endif ?>
						</div><!--card-body-->
					</div><!--card h-100-->
					<!--End of logs-->
				</form>
				<button type="button" onClick="window.location.reload();" class="btn btn-outline btn-primary" style="position:relative; top:10px;"><i class="fas fa-sync-alt"></i> <?php echo _(" Refresh") ?></a>	
      </div><!--card-body-->
    </div><!--card-->
  </div><!--col-lg-12-->
</div><!--row-->
