<div class="row">
  <div class="col-lg-12">
    <div class="card">
      <div class="card-header">
	<div class="row">
	  <div class="col">
	    <i class="fas fa-list fa-fw mr-2"></i><?php echo _("Node List"); ?>
	  </div>
	</div><!--row-->
      </div><!--card-header-->
      <div class="card-body">

	<!--Export Data-->
	<div class="row">
	  <div class="col-lg-12">
	    <div class="card mb-3">
	      <div class="card-body">

		<h4 class="card-title">Export Data</h4>
		<form method="post">
		  <?php echo CSRFTokenFieldTag() ?>
		
		  <label for="startDate">Start Date</label>
		  <input type="datetime-local" id="startDate" name="startDate" value="2010-01-01T00:00">

		  <label for="endDate" style="position:relative; left:20px">End Date</label>
		  <input type="datetime-local" id="endDate" name="endDate" value="<?php echo date("Y-m-d\TH:i"); ?>" style="position:relative; left:20px">

		  <input type="submit" class="btn btn-primary" value="Export Data" name="exportButton" style="position:relative; left:40px; bottom:2px"/>

		</form>

		<?php if ($csvFileReady){ echo "<a href='data:text/csv;charset=utf-8,$csvFileString' target=_blank download=\"data.csv\">Download CSV</a>"; } ?>

	      </div>
	    </div>  
	  </div>
	</div><!--row-->

	<!--Nodes-->
	<div class="row">
	  <div class="col-sm-6">
	    <div class="card h-100">
	      <div class="card-body">
		<h4 class="card-title">Nodes</h4>

		<form action="#" method="post">
	        <?php echo CSRFTokenFieldTag() ?>
		  <select name="nodes" id="nodes" size="10" style="width:400px;">
		    <?php
				$i = 0;
				while ($i != $totalNodes){?>
				<option value="<?php echo $i; ?>"><?php echo ''.implode($nodeList[$i], ' '); ?></option>
				<?php
				$i++;
				}
            	    ?>
		  </select>

		  <!--Buttons-->
		  <?php if (!$confirmDataDeletion && !$confirmNodeDeletion): ?>
			<br><br>

			<input type="submit" class="btn btn-primary" value="Get Sensors" name="getSensors" />
			<input type="submit" class="btn btn-danger"  value="Delete Synced Data" name="deleteData" />
			<input type="submit" class="btn btn-danger"  value="Delete Node" name="deleteNode" />

			<br><br>
		  <?php endif ?>

		  <!--Display Sensor table-->
		  <?php if ($getSensors): ?>
		    <h4>Node Name</h4>
		    <input type="text" id="nodeName" name="nodeName" value="<?php echo $selectedName; ?>">
		    <input type="submit" class="btn btn-primary" name="updateNodeName" value="Update Node Name" style="position:relative; left:10px; bottom:2px;">
	
		    <br><br>
		  <?php endif ?>
		  
		  <!--Confirm deletion buttons-->
		  <?php if ($confirmDataDeletion): ?>
			<h4 class="mt-3" style="font-size:24px;"><?php echo _("Delete synced data for node $selectedPhyID - $selectedName ?"); ?></h4>
		    <input type="submit" class="btn btn-danger" value="Confirm" name="confirmDeleteData" />
			<input type="submit" class="btn btn-warning" value="Cancel" name="cancelDeleteData" />
		  <?php endif?>
		  
		  <?php if ($confirmNodeDeletion): ?>
			<h4 class="mt-3" style="font-size:24px;"><?php echo _("Delete node $selectedPhyID - $selectedName ?"); ?></h4>
		    <input type="submit" class="btn btn-danger" value="Confirm" name="confirmDeleteNode" />
			<input type="submit" class="btn btn-warning" value="Cancel" name="cancelDeleteNode" />
		  <?php endif ?>

		  <input type="hidden" name="hiddenPhyID" value="<?php echo $selectedPhyID; ?>">
		  <input type="hidden" name="hiddenName"  value="<?php echo $selectedName;  ?>">

		</form>

	      </div><!--card-body-->
	    </div><!--card h-100-->
	  </div><!--col-sm-6-->

	  <!--Sensors-->
	  <?php if ($getSensors): ?>

  	    <div class="col-sm-6">
            <div class="card h-100">
                <div class="card-body">
				  <form method="post">
	        		<?php echo CSRFTokenFieldTag() ?>

					<table style='margin-bottom: 20px; margin-top: 10px;' cellpadding=3 border=2>
						<tbody>
							<tr>
								<td width=60  align='center'>Input</td>
								<td width=160 align='center'>Name</td>
								<td width=120 align='center'>Last Reading</td>
								<td width=200 align='center'>Last Reading Date</td>
								<td width=90  align='center'></td>
							</tr>

							<?php 
							$inputs = 0;
							if (!empty($sensorData)){
								while (isset($sensorData[$inputs]['node'])){
									for($check = 0; isset($sensorData[$check]['input']); $check++){
										if ($sensorData[$inputs]['input'] == $sensorNames[$check]['input']){
											
											$sensorName = $sensorNames[$check]['name'];
											$sensorInput = "Input_$inputs";
											$buttonName = "getGraph_$inputs";

											echo "<tr>
											<td align='center'>". $sensorData[$inputs]['input'] ."</td>
											<td align='center'><input type='text' id='name' name='$sensorInput' value='$sensorName'></td>
											<td align='center'>". $sensorData[$inputs]['value'] ."</td>
											<td style='white-space:nowrap;' align='center'>". $sensorData[$inputs]['ts'] ."</td>
											<td align='center'><input type='submit' class='btn btn-primary' value='Graph' name='$buttonName' /></td>
											</tr>";	
										}
									}
									$inputs++;
								}  
							}
							else{
								for($check = 0; $check < count($sensorNames); $check++){
									
									$sensorName = $sensorNames[$check]['name'];
									$sensorInput = "Input_$inputs";
									$buttonName = "getGraph_$inputs";

									$inputs++;
									
									echo "<tr>
									<td align='center'>". $sensorNames[$check]['input'] ."</td>
									<td align='center'><input type='text' id='name' name='$sensorInput' value='$sensorName'/></td>
									<td align='center'>-------</td>
									<td align='center'>-------</td>
									<td align='center'><input type='submit' class='btn btn-primary' value='Graph' name='$buttonName' /></td>
									</tr>";
								}
							}
							?>	

						</tbody>
					</table>

					<input type="submit" class="btn btn-primary"  value="Update Sensor Names" name="updateSensorNames" />

					<input type="hidden" name="hiddenSensorList"  value="<?php echo base64_encode(serialize($sensorNames)); ?>">
					<input type="hidden" name="hiddenNumOfInputs" value="<?php echo $totalSensors;  ?>">
					<input type="hidden" name="hiddenPhyID2" 	  value="<?php echo $selectedPhyID; ?>">

			      </form>

                </div><!--card-body-->
              </div><!--card h-100-->
            </div><!--col-sm-6-->

	  <?php endif ?>

	</div><!--row-->
	<?php if ($getSensorGraph): ?>
	    <canvas id="chart"></canvas>
	<?php endif ?>
		<p style="font-style:italic; position:relative; top:15px;">Values displayed may not have synced to Analytics yet</p>
		<button type="button" onclick="window.location.reload();" class="btn btn-outline btn-primary" style="position:relative; top:10px;"><i class="fas fa-sync-alt"></i> Refresh</button>
      </div><!--card-body-->
    </div><!--card-->
  </div><!--col-lg-12-->
</div><!--row-->
