<?php

include('includes/sysstats.php');

?>
<!-- basic tab -->
<div role="tabpanel" class="tab-pane active" id="basic">
  <div class="row">
    <div class="col-lg-6">

      <form name="syncPreferences" method="POST">
        <?php echo CSRFTokenFieldTag() ?>

        <!--Sync Timer-->
        <h4 class="mt-3"><?php echo _("Sync Timer"); ?></h4>
        <div class="info-value" style="position:relative; right:10px; font-size:16px;"><?php echo _($syncTimerStr); ?></div>
        <br>

        <div class="row" style="position:relative; bottom:5px;">
          <div class="row">
            <input type="number" min="0" max="23" name="hours"   style="width:60px; height:30px; position:relative; left:23px; top:15px;">
            <div class="info-value col-xs-3" style="position:relative; left:15px; top:17px; font-size:16px;"><?php echo _("Hour(s)"); ?></div>
            <input type="number" min="0" max="59" name="minutes" style="width:60px; height:30px; position:relative; left:22px; top:15px;">
            <div class="info-value col-xs-3" style="position:relative; left:15px; top:17px; font-size:16px;"><?php echo _("Minute(s)"); ?></div>
            <input type="number" min="0" max="59" name="seconds" style="width:60px; height:30px; position:relative; left:22px; top:15px;">
            <div class="info-value col-xs-3" style="position:relative; left:15px; top:17px; font-size:16px;"><?php echo _("Second(s)"); ?></div>
            <input type="submit" class="btn btn-primary" value="<?php echo _("Update Timer"); ?>" name="updateTimer" style="position:relative; left:25px; top:12px;">
          </div><!--row-->
        </div><!--row-->

        <br>
        <br>

        <!--Clear Interval-->
        <hr class="sidebar-divider my-0">
        <h4 class="mt-3"><?php echo _("Delete Synced Data"); ?></h4>
        <div class="info-value" style="position:relative; right:10px; font-size:16px;"><?php echo _($clearIntvStr); ?></div>
        <br>

        <input type="submit" class="btn btn-primary" value="<?php echo _("Do not delete any synced data"); ?>" name="dontDeleteSyncedData">
        <div class="info-value" style="position:relative; top:10px; right:10px; font-size:16px;"><?php echo _("Or"); ?></div>
        <div class="row" style="position:relative; bottom:0px;">
          <div class="row">
            <div class="info-value col-xs-3" style="position:relative; left:15px; top:17px; font-size:16px;"><?php echo _("Delete synced data older than"); ?></div>
            <input type="number" min="7" name="clearInterval" style="width:60px; height:30px; position:relative; left:22px; top:15px;">
            <div class="info-value col-xs-3" style="position:relative; left:15px; top:17px; font-size:16px;"><?php echo _("days (every time the TiG syncs)"); ?></div>
            <input type="submit" class="btn btn-primary" value="<?php echo _("Update"); ?>" name="updateClearInterval" style="position:relative; left:25px; top:12px;">
          </div><!--row-->
        </div><!--row-->

      </form>
      
      <br>
      <br>
      <hr class="sidebar-divider my-0">

      <?php if ($validatedSMT): ?>
        <br>
        <form name="comm" method="POST">
          <?php echo CSRFTokenFieldTag() ?>

          <!--Decommission-->
          <?php if ($commissioned): ?>

            <input type="checkbox" name='unserialize' checked>
            <label for="unserialize" style="position:relative;">Unserialize</label>
            <input type="submit" class="btn btn-primary" value="<?php echo _("Decommission"); ?>" name="decommission" style="position:relative; left:10px;">
            
          <!--Commission-->
          <?php else: ?>

            <!--Serial Number-->
            <?php if ($hostnameRequired): ?>
              <div class="row" style="position:relative; left:12px;">
                <div class="row">
                  <div class="info-value col-xs-3" style="position:relative;"><?php echo _("Serial Number"); ?></div>
                  <input type="number" min="1000" max="9999" name="serialNum" style="width:80px; height:30px; position:relative; bottom:4px; left:10px;">
                </div>
              </div>
              <br>
            <?php endif ?>

            <!--Project ID-->
            <div class="row" style="position:relative; left:12px;">
              <div class="row">
                <div class="info-value col-xs-3" style="position:relative;"><?php echo _("Project ID"); ?></div>
                <input type="number" min="1" name="projectID" style="width:80px; height:30px; position:relative; bottom:4px; left:10px;">
              </div>
            </div>

            <!--Job ID-->
            <div class="row" style="position:relative; left:12px; top:7px;">
              <div class="row">
                <div class="info-value col-xs-3" style="position:relative;"><?php echo _("Job ID"); ?></div>
                <input type="number" min="1" name="jobID" style="width:80px; height:30px; position:relative; bottom:4px; left:32px;">
              </div>
            </div>

            <input type="submit" class="btn btn-primary" value="<?php echo _("Commission"); ?>" name="commission" style="position:relative; top:15px;">

          <?php endif ?>

        </form>

        <br>
        <hr class="sidebar-divider my-0" style="position:relative; top:5px;">

      <?php endif ?>

      <div class="row ml-1">
        <div class="col-sm">
          <br>
          <div class="row mb-1">
            <div class="info-item col-xs-3"><?php echo _("Pi Revision"); ?></div><div class="info-value col-xs-3"><?php echo htmlspecialchars(RPiVersion(), ENT_QUOTES); ?></div>
          </div>
          <div class="row mb-1">
            <div class="info-item col-xs-3"><?php echo _("OS"); ?></div><div class="info-value col-xs-3"><?php echo htmlspecialchars($os, ENT_QUOTES); ?></div>
          </div>
          <div class="row mb-1">
            <div class="info-item col-xs-3"><?php echo _("Kernel"); ?></div><div class="info-value col-xs-3"><?php echo htmlspecialchars($kernel, ENT_QUOTES); ?></div>
          </div>
        </div>
      </div>
	    <br>

      <div class="mb-1"><?php echo _("Memory Used"); ?></div>
      <div class="progress mb-2" style="height: 20px;">
        <div class="progress-bar bg-<?php echo htmlspecialchars($memused_status, ENT_QUOTES); ?>"
            role="progressbar" aria-valuenow="<?php echo htmlspecialchars($memused, ENT_QUOTES); ?>" aria-valuemin="0" aria-valuemax="100"
            style="width: <?php echo htmlspecialchars($memused, ENT_QUOTES); ?>%"><?php echo htmlspecialchars($memused, ENT_QUOTES); ?>%
        </div>
      </div>
      <div class="mb-1"><?php echo _("CPU Load"); ?></div>
      <div class="progress mb-2" style="height: 20px;">
        <div class="progress-bar bg-<?php echo htmlspecialchars($cpuload_status, ENT_QUOTES); ?>"
            role="progressbar" aria-valuenow="<?php echo htmlspecialchars($cpuload, ENT_QUOTES); ?>" aria-valuemin="0" aria-valuemax="100"
            style="width: <?php echo htmlspecialchars($cpuload, ENT_QUOTES); ?>%"><?php echo htmlspecialchars($cpuload, ENT_QUOTES); ?>%
        </div>
      </div>
      <div class="mb-1"><?php echo _("CPU Temp"); ?></div>
      <div class="progress mb-4" style="height: 20px;">
        <div class="progress-bar bg-<?php echo htmlspecialchars($cputemp_status, ENT_QUOTES); ?>"
            role="progressbar" aria-valuenow="<?php echo htmlspecialchars($cputemp, ENT_QUOTES); ?>" aria-valuemin="0" aria-valuemax="100"
            style="width: <?php echo htmlspecialchars(($cputemp*1.2), ENT_QUOTES); ?>%"><?php echo htmlspecialchars($cputemp, ENT_QUOTES); ?>°C
        </div>
      </div>
      <br>
      <form action="system_info" method="POST">
        <?php echo CSRFTokenFieldTag() ?>
        <?php if (!RASPI_MONITOR_ENABLED) : ?>
            <input type="submit" class="btn btn-warning" name="systemReboot"   value="<?php echo _("Reboot"); ?>" />
            <input type="submit" class="btn btn-warning" name="systemShutdown" value="<?php echo _("Shutdown"); ?>" />
        <?php endif ?>
        <button type="button" onClick="window.location.reload();" class="btn btn-outline btn-primary"><i class="fas fa-sync-alt"></i> <?php echo _("Refresh") ?></a>
     </form>
      </div>
    </div>
  </div>

